// generated by mBlock5 for mBot Ranger
// codes make you happy

#include <Arduino.h>
#include <Wire.h>
#include <SoftwareSerial.h>
#include <MeAuriga.h>

MeEncoderOnBoard Encoder_1(SLOT1);
MeEncoderOnBoard Encoder_2(SLOT2);
MeLightSensor lightsensor_12(12);
Servo servo_9_1;
MePort port_9(9);
Servo servo_9_2;

SoftwareSerial Xbee(A11, A6); // RX, TX

unsigned char vals[7];  // temporary values, moved after we confirm checksum
int index;              // -1 = waiting for new packet
int checksum;
//int cmdFw;
//int cmdRot;
unsigned char status;
signed char joysticLV = 0;    // vertical stick movement = forward speed
signed char joysticLH = 0;    // horizontal stick movement = sideways or angular speed
signed char joysticRV = 0;    // vertical stick movement = tilt
signed char joysticRH = 0;    // horizontal stick movement = pan (when we run out of pan, turn body?)
unsigned char buttons;  //

void isr_process_encoder1(void)
{
  if (digitalRead(Encoder_1.getPortB()) == 0) {
    Encoder_1.pulsePosMinus();
  } else {
    Encoder_1.pulsePosPlus();
  }
}
void isr_process_encoder2(void)
{
  if (digitalRead(Encoder_2.getPortB()) == 0) {
    Encoder_2.pulsePosMinus();
  } else {
    Encoder_2.pulsePosPlus();
  }
}
void move(int leftSpeed, int rightSpeed)
{
  Encoder_1.setTarPWM(leftSpeed);
  Encoder_2.setTarPWM(rightSpeed);
 
}

void _delay(float seconds) {
  if (seconds < 0.0) {
    seconds = 0.0;
  }
  long endTime = millis() + seconds * 10;
  
  while (millis() < endTime) {
    _loop();
    

  }
}

bool commanderRead()
{
  while (Xbee.available() > 0) {
    if (index == -1) {       // looking for new packet
      if (Xbee.read() == 0xff) {
        index = 0;
        checksum = 0;
      }
    } else if (index == 0) {
      vals[index] = (unsigned char) Xbee.read();
      if (vals[index] != 0xff) {
        checksum += (int) vals[index];
        index++;
      }
    } else {
      vals[index] = (unsigned char) Xbee.read();
      checksum += (int) vals[index];
      index++;
      if (index == 7) { // packet complete
        Serial.println("packet complete");
        if (checksum % 256 != 255) {
          index = -1;
        }


        else {
          joysticRV = (signed char)( (int)vals[3] ); 
          Serial.println("joysticRV= "+joysticRV);
          joysticLV = (signed char)( (int)vals[0] );
          Serial.println("joysticLV= "+joysticLV);
          joysticRH = (signed char)( (int)vals[2] );
          Serial.println("joysticRH= "+joysticRH);
          joysticLH = (signed char)( (int)vals[1] );
          Serial.println("joysticLH= "+joysticLH);

          buttons = vals[4];
        }
        index = -1;
        Xbee.flush();
        return 1;
      }

    }
  }
  return 0;
}

void setup() {
  Serial.begin(38400);
  Xbee.begin(38400);
  TCCR1A = _BV(WGM10);
  TCCR1B = _BV(CS11) | _BV(WGM12);
  TCCR2A = _BV(WGM21) | _BV(WGM20);
  TCCR2B = _BV(CS21);
  servo_9_1.attach(port_9.pin1());
  servo_9_2.attach(port_9.pin2());
  servo_9_1.write(90);
  servo_9_2.write(90);
  attachInterrupt(Encoder_1.getIntNum(), isr_process_encoder1, RISING);
  attachInterrupt(Encoder_2.getIntNum(), isr_process_encoder2, RISING);
  randomSeed((unsigned long)(lightsensor_12.read() * 123456));
  while (1) {
    if (commanderRead()) {
     
     

        move((joysticLV+joysticLH)/ 100.0 * 255, (joysticLV-joysticLH) / 100.0 * 255);
         _delay(20);
      if (joysticRV <12){
        joysticRV=12;
        }
       servo_9_1.write((-joysticRH)+90);
       Serial.println("joysticRV =" + joysticRV);
      servo_9_2.write((-joysticRV*0.6)+120);
        Serial.println("move?");
       
       
        joysticLV=0;
        joysticLH = 0;
        Encoder_1.setTarPWM(0);
        Encoder_2.setTarPWM(0);
        _delay(5);

     
     
    }
    _loop();
  }


}



void _loop() {
  Encoder_1.loop();
  Encoder_2.loop();
}

void loop() {




  
}
